/* -*- tab-width: 4 -*- */

#include "elkkernel.h"

/* extern char *malloc(), *realloc(); */

CHAR *Safe_Malloc (unsigned size) {
	CHAR *ret;

	Disable_Interrupts;
	if ((ret = (CHAR *)malloc (size)) == 0)
		if (Interpreter_Initialized)
			Primitive_Error (x_("not enough memory to malloc ~s bytes"),
				Make_Integer (size));
		else
			Fatal_Error (x_("not enough memory to malloc %u bytes"), size);
	Enable_Interrupts;
	return ret;
}

CHAR *Safe_Realloc (CHAR *ptr, unsigned size) {
	CHAR *ret;

	Disable_Interrupts;
	if ((ret = (CHAR *)(ptr ? realloc (ptr, size) : malloc (size))) == 0)
		if (Interpreter_Initialized)
			Primitive_Error (x_("not enough memory to malloc ~s bytes"),
				Make_Integer (size));
		else
			Fatal_Error (x_("not enough memory to malloc %u bytes"), size);
	Enable_Interrupts;
	return ret;
}
