/* -*- tab-width: 4 -*-
 *
 *     ********************************************************************* 
 *     * Copyright (C) 1988, 1990 Stanford University.                     * 
 *     * Permission to use, copy, modify, and distribute this              * 
 *     * software and its documentation for any purpose and without        * 
 *     * fee is hereby granted, provided that the above copyright          * 
 *     * notice appear in all copies.  Stanford University                 * 
 *     * makes no representations about the suitability of this            * 
 *     * software for any purpose.  It is provided "as is" without         * 
 *     * express or implied warranty.                                      * 
 *     ********************************************************************* 
 */
#include "global.h"
#include "sim.h"
#include "irsimnet.h"
#include "irsimglobals.h"

	/* number of bytes/words per page */
#define	DATABYTES		4096

typedef union DataObject *Pointer;

typedef union DataObject		/* Basic data object (i.e. `machine word') */
{
	Pointer  ptr;
	int      num;
	double   dble;
	int      align[1];
} DataObject;

/*
 * Return a linked list of elements, each 'nbytes' long in size.
 */
#ifdef DEBUGMEMORY
MList _irsim_MallocList(int nbytes, int no_mem_exit, CHAR *file, INTBIG line)
#else
MList irsim_MallocList(int nbytes, int no_mem_exit)
#endif
{
	int      nelem;
	Pointer  head, tail;

	if (nbytes <= 0) return(NULL);

	nelem = (nbytes < 2 * DATABYTES) ? DATABYTES / nbytes : 2;
#ifdef DEBUGMEMORY
	head = tail = (Pointer) _emalloc(nbytes, sim_tool->cluster, file, line);
#else
	head = tail = (Pointer) emalloc(nbytes, sim_tool->cluster);
#endif
	if (head == NULL) return(NULL);

	while(--nelem > 0)
	{
#ifdef DEBUGMEMORY
		tail->ptr = (Pointer)_emalloc(nbytes, sim_tool->cluster, file, line);
#else
		tail->ptr = (Pointer)emalloc(nbytes, sim_tool->cluster);
#endif
		if (tail->ptr == NULL)
		{
			while(head != NULL)
			{				/* free everything already Malloc`d */
				tail = head->ptr;
				efree((CHAR *)head);
				head = tail;
			}
			return(NULL);
		}
		tail = tail->ptr;
	}
	tail->ptr = NULL;
	return((MList)head);
}
